package com.izouma.zhirongip.web;

import com.izouma.zhirongip.domain.User;
import com.izouma.zhirongip.dto.PageQuery;
import com.izouma.zhirongip.dto.UserRegister;
import com.izouma.zhirongip.enums.AuthorityName;
import com.izouma.zhirongip.exception.BusinessException;
import com.izouma.zhirongip.repo.UserRepo;
import com.izouma.zhirongip.security.Authority;
import com.izouma.zhirongip.security.JwtTokenUtil;
import com.izouma.zhirongip.security.JwtUserFactory;
import com.izouma.zhirongip.service.UserService;
import com.izouma.zhirongip.utils.ObjUtils;
import com.izouma.zhirongip.utils.SecurityUtils;
import com.izouma.zhirongip.utils.excel.ExcelUtils;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Collections;
import java.util.List;
import java.util.Set;

@AllArgsConstructor
@RestController
@RequestMapping("/user")
public class UserController extends BaseController {
    private final UserRepo     userRepo;
    private final UserService  userService;
    private final JwtTokenUtil jwtTokenUtil;

    @PostMapping("/register")
    public User register(@RequestParam String username,
                         @RequestParam String password) {
        UserRegister user = UserRegister.builder()
                .username(username)
                .nickname(username)
                .password(new BCryptPasswordEncoder().encode(password))
                .authorities(Collections.singleton(Authority.get(AuthorityName.ROLE_USER)))
                .build();
        return userService.create(user);
    }

    @PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/create")
    public User create(@RequestBody UserRegister userRegister) {
        return userService.create(userRegister);
    }

    //    @PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public User save(@RequestBody User user) {
        Authority institution = Authority.get(AuthorityName.ROLE_INSTITUTION);
        Authority personal = Authority.get(AuthorityName.ROLE_PERSONAL);
        if (user.getId() != null) {
            User orig = userRepo.findById(user.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, user);
            Set<Authority> authorities = orig.getAuthorities();
            if (authorities.contains(institution) && authorities.contains(personal)) {
                throw new BusinessException("只能认证一种");
            }
            return userRepo.save(orig);
        }
        Set<Authority> authorities = user.getAuthorities();
        if (authorities.contains(institution) && authorities.contains(personal)) {
            throw new BusinessException("只能认证一种");
        }
        return userRepo.save(user);
    }

    @PostMapping("/saveInfo")
    public User saveAvatar(@RequestParam String nickname, @RequestParam String avatar) {
        User user = SecurityUtils.getAuthenticatedUser();
        user.setAvatar(avatar);
        user.setNickname(nickname);
        Authority institution = Authority.get(AuthorityName.ROLE_INSTITUTION);
        Authority personal = Authority.get(AuthorityName.ROLE_PERSONAL);
        if (user.getId() != null) {
            User orig = userRepo.findById(user.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, user);
            Set<Authority> authorities = orig.getAuthorities();
            if (authorities.contains(institution) && authorities.contains(personal)) {
                throw new BusinessException("只能认证一种");
            }
            return userRepo.save(orig);
        }
        Set<Authority> authorities = user.getAuthorities();
        if (authorities.contains(institution) && authorities.contains(personal)) {
            throw new BusinessException("只能认证一种");
        }
        return userRepo.save(user);
    }

    @GetMapping("/my")
    public User my() {
        return userRepo.findById(SecurityUtils.getAuthenticatedUser().getId())
                .orElseThrow(new BusinessException("用户不存在"));
    }

    @GetMapping("/myAdmin")
    @PreAuthorize("hasRole('ADMIN')")
    public User myAdmin() {
        return userRepo.findById(SecurityUtils.getAuthenticatedUser().getId())
                .orElseThrow(new BusinessException("用户不存在"));
    }

    @PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<User> all(@RequestBody PageQuery pageQuery) {
        return userService.all(pageQuery);
    }

    @PreAuthorize("hasRole('ADMIN')")
    @GetMapping("/get/{id}")
    public User get(@PathVariable Long id) {
        return userRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        userService.del(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<User> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }

    @PostMapping("/getMaUserInfo")
    @ApiOperation(value = "获取小程序用户信息")
    public User getMaUserInfo(String sessionKey, String rawData, String signature, String encryptedData, String iv) {
        User user = userService.getMaUserInfo(sessionKey, rawData, signature, encryptedData, iv);
        if (user != null) {
            return user;
        }
        throw new BusinessException("获取用户信息失败");
    }

    @PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/setPasswordAdmin")
    public String setPasswordAdmin(@RequestParam Long userId, @RequestParam String password) {
        return userService.setPassword(userId, password);
    }

    @PostMapping("/changePassword")
    public String changePassword(@RequestParam String password, @RequestParam String key, @RequestParam String code) {
        return userService.setPassword(SecurityUtils.getAuthenticatedUser().getId(), key, code, password);
    }

    @PostMapping("/changePw")
    public String changePassword(@RequestParam String password, @RequestParam String newPassword) {
        return userService.changePassword(SecurityUtils.getAuthenticatedUser().getId(), password, newPassword);
    }

    @PreAuthorize("hasRole('ADMIN')")
    @GetMapping("/getToken/{userId}")
    public String getToken(@PathVariable Long userId) {
        return jwtTokenUtil.generateToken(JwtUserFactory.create(userRepo.findById(userId)
                .orElseThrow(new BusinessException("用户不存在"))));
    }

    @ApiOperation("修改手机号")
    @PostMapping("/changePhone")
    public User changePhone(@RequestParam String phone) {
        return userService.changePhone(phone, SecurityUtils.getAuthenticatedUser().getId());
    }

    @ApiOperation("忘记密码")
    @PostMapping("/forgotPassword")
    public String forgotPassword(@RequestParam String phone, @RequestParam String password) {
        return userService.forgotPassword(phone, password);
    }
}
